import { Component, forwardRef, HostBinding, HostListener, Input, ViewChild, NgModule } from '@angular/core';
import { NG_VALUE_ACCESSOR } from '@angular/forms';
import 'bootstrap-datepicker';
import { CommonModule } from '@angular/common';

var NGQ_DATETIME_VALUE_ACCESSOR = {
    provide: NG_VALUE_ACCESSOR,
    useExisting: forwardRef(function () { return NgqDatepickerComponent; }),
    multi: true
};
var BASE_OPTION = { autoclose: true, format: 'dd/mm/yyyy' };
var THAI_OPTION = Object.assign({}, BASE_OPTION, { thaiyear: true });
var NgqDatepickerComponent = /** @class */ (function () {
    function NgqDatepickerComponent() {
        this.propagateChange = function (_) { };
        this.onTouched = function () { };
    }
    Object.defineProperty(NgqDatepickerComponent.prototype, "tabindexAttr", {
        get: function () {
            return this.tabindex === undefined ? '-1' : undefined;
        },
        enumerable: true,
        configurable: true
    });
    NgqDatepickerComponent.prototype.ngAfterViewInit = function () {
        var _this = this;
        jQuery(this.input.nativeElement).datepicker(THAI_OPTION);
        jQuery(this.input.nativeElement)
            .datepicker()
            .on('changeDate', function (e) {
            _this._date = e.date;
            _this.propagateChange(_this._date);
        });
        jQuery(this.input.nativeElement).datepicker('update', this._date);
        jQuery(this.input.nativeElement).prop('disabled', this._isDisabled);
    };
    NgqDatepickerComponent.prototype.writeValue = function (obj) {
        this._date = obj;
    };
    NgqDatepickerComponent.prototype.registerOnChange = function (fn) {
        this.propagateChange = fn;
    };
    NgqDatepickerComponent.prototype.registerOnTouched = function (fn) { };
    NgqDatepickerComponent.prototype.setDisabledState = function (isDisabled) {
        this._isDisabled = isDisabled;
    };
    return NgqDatepickerComponent;
}());
NgqDatepickerComponent.decorators = [
    { type: Component, args: [{
                selector: 'ngq-datepicker',
                template: "<input #input type=\"text\">\n",
                styles: ["h1{color:red}"]
            },] },
];
NgqDatepickerComponent.ctorParameters = function () { return []; };
NgqDatepickerComponent.propDecorators = {
    "tabindex": [{ type: Input },],
    "input": [{ type: ViewChild, args: ['input',] },],
    "onTouched": [{ type: HostListener, args: ['blur',] },],
    "tabindexAttr": [{ type: HostBinding, args: ['attr.tabindex',] },],
};
var NgqDatepickerModule = /** @class */ (function () {
    function NgqDatepickerModule() {
    }
    return NgqDatepickerModule;
}());
NgqDatepickerModule.decorators = [
    { type: NgModule, args: [{
                imports: [CommonModule],
                declarations: [NgqDatepickerComponent],
                exports: [NgqDatepickerComponent]
            },] },
];
NgqDatepickerModule.ctorParameters = function () { return []; };

export { NgqDatepickerModule, NgqDatepickerComponent as ɵa };
//# sourceMappingURL=ngq-datepicker.js.map
